﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using ingesup_ERP.Models;

namespace ingesup_ERP.Areas.Admin.Controllers
{
    [Authorize(Roles="Admin")]
    public class AdminController : Controller
    {
        private db db = new db();

        //
        // GET: /Admin/Admin/

        public ViewResult Index()
        {
            return View(db.ADMINISTRATEUR.ToList());
        }

        //
        // GET: /Admin/Admin/Details/5

        public ViewResult Details(string id)
        {
            ADMINISTRATEUR administrateur = db.ADMINISTRATEUR.Single(a => a.LOGINPERS == id);
            return View(administrateur);
        }

        //
        // GET: /Admin/Admin/Create

        public ActionResult Create()
        {
            return View();
        } 

        //
        // POST: /Admin/Admin/Create

        [HttpPost]
        public ActionResult Create(ADMINISTRATEUR administrateur)
        {
            if (ModelState.IsValid)
            {
                administrateur.LOGINPERS = administrateur.PRENOMPERS[0].ToString() + administrateur.NOMPERS;
                administrateur.MDPPERS = Functions.getHash(administrateur.MDPPERS);
                db.ADMINISTRATEUR.AddObject(administrateur);
                Roles.AddUserToRole(administrateur.LOGINPERS, db.PersonneView.Single(m => m.LOGIN == administrateur.LOGINPERS).TYPE);
                db.SaveChanges();
                return RedirectToAction("Index");  
            }

            return View(administrateur);
        }
        
        //
        // GET: /Admin/Admin/Edit/5
 
        public ActionResult Edit(string id)
        {
            ADMINISTRATEUR administrateur = db.ADMINISTRATEUR.Single(a => a.LOGINPERS == id);
            return View(administrateur);
        }

        //
        // POST: /Admin/Admin/Edit/5

        [HttpPost]
        public ActionResult Edit(ADMINISTRATEUR administrateur)
        {
            if (ModelState.IsValid)
            {
                db.ADMINISTRATEUR.Attach(administrateur);
                db.ObjectStateManager.ChangeObjectState(administrateur, EntityState.Modified);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            return View(administrateur);
        }

        //
        // GET: /Admin/Admin/Delete/5
 
        public ActionResult Delete(string id)
        {
            ADMINISTRATEUR administrateur = db.ADMINISTRATEUR.Single(a => a.LOGINPERS == id);
            return View(administrateur);
        }

        //
        // POST: /Admin/Admin/Delete/5

        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(string id)
        {            
            ADMINISTRATEUR administrateur = db.ADMINISTRATEUR.Single(a => a.LOGINPERS == id);
            db.ADMINISTRATEUR.DeleteObject(administrateur);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}