﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ingesup_ERP.Models;

namespace ingesup_ERP.Areas.Admin.Controllers
{
    [Authorize(Roles = "Admin")]
    public class ClasseController : Controller
    {
        private db db = new db();

        //
        // GET: /Admin/Classe/

        public ViewResult Index()
        {
            return View(db.CLASSE.ToList());
        }

        //
        // GET: /Admin/Classe/Details/5

        public ViewResult Details(int id)
        {
            CLASSE classe = db.CLASSE.Single(c => c.IDCLASSE == id);
            return View(classe);
        }

        //
        // GET: /Admin/Classe/Create

        public ActionResult Create()
        {
            return View();
        } 

        //
        // POST: /Admin/Classe/Create

        [HttpPost]
        public ActionResult Create(CLASSE classe)
        {
            if (ModelState.IsValid)
            {
                db.CLASSE.AddObject(classe);
                db.SaveChanges();
                return RedirectToAction("Index");  
            }

            return View(classe);
        }
        
        //
        // GET: /Admin/Classe/Edit/5
 
        public ActionResult Edit(int id)
        {
            CLASSE classe = db.CLASSE.Single(c => c.IDCLASSE == id);
            return View(classe);
        }

        //
        // POST: /Admin/Classe/Edit/5

        [HttpPost]
        public ActionResult Edit(CLASSE classe)
        {
            if (ModelState.IsValid)
            {
                db.CLASSE.Attach(classe);
                db.ObjectStateManager.ChangeObjectState(classe, EntityState.Modified);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            return View(classe);
        }

        //
        // GET: /Admin/Classe/Delete/5
 
        public ActionResult Delete(int id)
        {
            CLASSE classe = db.CLASSE.Single(c => c.IDCLASSE == id);
            return View(classe);
        }

        //
        // POST: /Admin/Classe/Delete/5

        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(int id)
        {            
            CLASSE classe = db.CLASSE.Single(c => c.IDCLASSE == id);
            db.CLASSE.DeleteObject(classe);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}