﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using ingesup_ERP.Models;

namespace ingesup_ERP.Areas.Admin.Controllers
{
    [Authorize(Roles = "Admin")]
    public class PedagogieController : Controller
    {
        private db db = new db();

        //
        // GET: /Admin/Pedagogie/

        public ViewResult Index()
        {
            return View(db.SERVICEPEDAGOGIQUE.ToList());
        }

        //
        // GET: /Admin/Pedagogie/Details/5

        public ViewResult Details(string id)
        {
            SERVICEPEDAGOGIQUE servicepedagogique = db.SERVICEPEDAGOGIQUE.Single(s => s.LOGINPERS == id);
            return View(servicepedagogique);
        }

        //
        // GET: /Admin/Pedagogie/Create

        public ActionResult Create()
        {
            return View();
        } 

        //
        // POST: /Admin/Pedagogie/Create

        [HttpPost]
        public ActionResult Create(SERVICEPEDAGOGIQUE servicepedagogique)
        {
            if (ModelState.IsValid)
            {
                servicepedagogique.LOGINPERS = servicepedagogique.PRENOMPERS[0].ToString() + servicepedagogique.NOMPERS;
                servicepedagogique.MDPPERS = Functions.getHash(servicepedagogique.MDPPERS);
                db.SERVICEPEDAGOGIQUE.AddObject(servicepedagogique);
                db.SaveChanges();
                Roles.AddUserToRole(servicepedagogique.LOGINPERS, db.PersonneView.Single(m => m.LOGIN == servicepedagogique.LOGINPERS).TYPE);
                return RedirectToAction("Index");  
            }

            return View(servicepedagogique);
        }
        
        //
        // GET: /Admin/Pedagogie/Edit/5
 
        public ActionResult Edit(string id)
        {
            SERVICEPEDAGOGIQUE servicepedagogique = db.SERVICEPEDAGOGIQUE.Single(s => s.LOGINPERS == id);
            return View(servicepedagogique);
        }

        //
        // POST: /Admin/Pedagogie/Edit/5

        [HttpPost]
        public ActionResult Edit(SERVICEPEDAGOGIQUE servicepedagogique)
        {
            if (ModelState.IsValid)
            {
                db.SERVICEPEDAGOGIQUE.Attach(servicepedagogique);
                db.ObjectStateManager.ChangeObjectState(servicepedagogique, EntityState.Modified);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            return View(servicepedagogique);
        }

        //
        // GET: /Admin/Pedagogie/Delete/5
 
        public ActionResult Delete(string id)
        {
            SERVICEPEDAGOGIQUE servicepedagogique = db.SERVICEPEDAGOGIQUE.Single(s => s.LOGINPERS == id);
            return View(servicepedagogique);
        }

        //
        // POST: /Admin/Pedagogie/Delete/5

        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(string id)
        {            
            SERVICEPEDAGOGIQUE servicepedagogique = db.SERVICEPEDAGOGIQUE.Single(s => s.LOGINPERS == id);
            db.SERVICEPEDAGOGIQUE.DeleteObject(servicepedagogique);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}