﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using ingesup_ERP.Models;

namespace ingesup_ERP.Areas.Admin.Controllers
{
    [Authorize(Roles="Admin")]
    public class ProfesseurController : Controller
    {
        private db db = new db();

        //
        // GET: /Admin/Professeur/

        public ViewResult Index()
        {
            return View(db.PROFESSEUR.ToList());
        }

        //
        // GET: /Admin/Professeur/Details/5

        public ViewResult Details(string id)
        {
            PROFESSEUR professeur = db.PROFESSEUR.Single(p => p.LOGINPERS == id);
            return View(professeur);
        }

        //
        // GET: /Admin/Professeur/Create

        public ActionResult Create()
        {
            return View();
        } 

        //
        // POST: /Admin/Professeur/Create

        [HttpPost]
        public ActionResult Create(PROFESSEUR professeur)
        {
            if (ModelState.IsValid)
            {
                professeur.LOGINPERS = professeur.PRENOMPERS[0].ToString() + professeur.NOMPERS;
                professeur.MDPPERS = Functions.getHash(professeur.MDPPERS);
                db.PROFESSEUR.AddObject(professeur);
                db.SaveChanges();
                Roles.AddUserToRole(professeur.LOGINPERS, db.PersonneView.Single(m => m.LOGIN == professeur.LOGINPERS).TYPE);
                return RedirectToAction("Index");  
            }

            return View(professeur);
        }
        
        //
        // GET: /Admin/Professeur/Edit/5
 
        public ActionResult Edit(string id)
        {
            PROFESSEUR professeur = db.PROFESSEUR.Single(p => p.LOGINPERS == id);
            return View(professeur);
        }

        //
        // POST: /Admin/Professeur/Edit/5

        [HttpPost]
        public ActionResult Edit(PROFESSEUR professeur)
        {
            if (ModelState.IsValid)
            {
                db.PROFESSEUR.Attach(professeur);
                db.ObjectStateManager.ChangeObjectState(professeur, EntityState.Modified);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            return View(professeur);
        }

        //
        // GET: /Admin/Professeur/Delete/5
 
        public ActionResult Delete(string id)
        {
            PROFESSEUR professeur = db.PROFESSEUR.Single(p => p.LOGINPERS == id);
            return View(professeur);
        }

        //
        // POST: /Admin/Professeur/Delete/5

        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(string id)
        {            
            PROFESSEUR professeur = db.PROFESSEUR.Single(p => p.LOGINPERS == id);
            db.PROFESSEUR.DeleteObject(professeur);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}