﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using ingesup_ERP.Models;

namespace ingesup_ERP.Controllers
{
    public class logController : Controller
    {
        private db bdd = new db();

        [AllowAnonymous]
        public ActionResult Connexion()
        {
            if (Request.IsAuthenticated)
            {
                return View("Connected");
            }
            return View();
        }

        [AllowAnonymous]
        [HttpPost]
        public ActionResult Connexion(PersonneView personne)
        {
            if (ModelState.IsValid)
            {
                personne.MDP = Functions.getHash(personne.MDP);
                if (Membership.ValidateUser(personne.LOGIN, personne.MDP))
                {
                    FormsAuthentication.SetAuthCookie(personne.LOGIN, true);
                    string role = bdd.PersonneView.SingleOrDefault(pers => pers.LOGIN == personne.LOGIN && pers.MDP == personne.MDP).TYPE;
                    bool rep = Roles.IsUserInRole(role);
                    if (rep)
                    {
                        Roles.AddUserToRole(personne.LOGIN, role);
                    }
                    return RedirectToAction("index", "home", new { area = role });
                }
                else
                {
                    ViewData["error"] = "Erreur d'identification";
                }
            }

            return View();
        }

        [Authorize]
        public ActionResult Deconnexion()
        {
            FormsAuthentication.SignOut();
            return RedirectToAction("Connexion");
        }
    }
}
